000100$SET NOTRACE
000200 IDENTIFICATION DIVISION.
000300 PROGRAM-ID. APP01P0N.
000400 AUTHOR. OBELIX84.
000500
000600*---------------------
000700* V1.0 du 27/11/2019 -
000800*-----------------------------------------------------------------
000900*           - APPAREILLAGE DE FICHIERS 0,1 POUR 0,N -
001000*
001100*-----------------------------------------------------------------
001200* Infos programme
001300*
001400*  - Sur PC (DOS) liens aux fichiers reels par variables envt
001500*    Par exemple:
001600*        set FICPMT=E:\FIC\FICPMT1
001700*        set FICMVT=E:\FIC\FICMVT1
001800*        rem appel au pgm (display sur E:\FIC\APP1.LST)
001900*        app01P0n > E:\FIC\APP1.LST
002000*
002100*  - Gestion des erreurs fichiers par declaratives
002200*  - GO TO uniquement vers sortie programme (GOBACK)
002300*-----------------------------------------------------------------
002400* Appareillage classique de fichiers permanent et mouvement
002500* tries sur un indicatif donne.
002600*  - Permanent (PMT) 0 ou 1 enregistrement  pour un indicatif
002700*  - Mouvement (MVT) 0 ou n enregistrements pour un indicatif
002800*
002900* Le traitement va consister a comparer les indicatifs et a
003000* realiser une mise  jour du fichier PMT avec le fichier MVT
003100* L'ecriture du permanent mis a jour se fera a la rupture
003200* sur l'indicatif
003300*
003400* On aura une iteration principale
003500* qui appellera 3 blocs de traitements principaux
003600* - PMT et MVT => Mise a jour de PMT par MVT
003700* - MVT seul   => Creation de PMT avec MVT
003800* - PMT seul   => Reconduction de PMT avec maj specifique
003900*
004000* 3 blocs de traitements secondaires
004100* - MAJ specifique au premier d'un groupe de meme indicatif
004200* - MAJ commune a tous les mouvements d'un groupe
004300* - Boucle de relecture pour traiter tous les mouvements du groupe
004400*
004500*-----------------------------------------------------------------
004600* Le traitement est simple. L'appareillage se fait sur l'indicatif
004700*  - MVT seul
004800*      On cree un PMT avec le premier MVT sans correspondance
004900*      Les autres MVT seront cumules sur le PMT (voir MVT + PMT)
005000*  - PMT seul
005100*      On reconduit le PMT a l'identique
005200*  - MVT + PMT
005300*      On  cumule le montant dans l'une des 2 zones montant
005400*      suivant le code ventilation qui contiendra 1 ou 2
005500*      1er montant pour code 1 - 2eme montant pour code 2
005600*
005700* En reel le premier passage se fera avec le fichier PMT absent
005800* ou vide (cas sous DOS) ce qui permettra de le creer
005900*-----------------------------------------------------------------
006000
006100 ENVIRONMENT DIVISION.
006200 CONFIGURATION SECTION.
006300*=====================
006400 SOURCE-COMPUTER. PC WITH DEBUGGING MODE.
006500 OBJECT-COMPUTER. PC.
006600*-----------------------------------------------------------------
006700 INPUT-OUTPUT SECTION.
006800*====================
006900*----------------------------------------------------------------
007000* Les SELECT et FD sont a adapter suivant l'environnement
007100* MAINFRAME ou autre. Celui-ci fonctionne avec du DOS sur PC
007200*----------------------------------------------------------------
007300 FILE-CONTROL.
007400     SELECT OPTIONAL
007500            FICPMT ASSIGN TO EXTERNAL FICPMT
007600                   ORGANIZATION IS LINE SEQUENTIAL
007700                   FILE STATUS  IS FS-PMT.
007800     SELECT FICMVT ASSIGN TO EXTERNAL FICMVT
007900                   ORGANIZATION IS LINE SEQUENTIAL
008000                   FILE STATUS  IS FS-MVT.
008100     SELECT FICOUT ASSIGN TO EXTERNAL FICOUT
008200                   ORGANIZATION IS LINE SEQUENTIAL
008300                   FILE STATUS  IS FS-OUT.
008400*-----------------------------------------------------------------
008500
008600 DATA DIVISION.
008700
008800 FILE SECTION.
008900*============
009000
009100 FD  FICPMT  RECORD CONTAINS 24 CHARACTERS.
009200 01  ART-PMT.
009300     05 INDIC-PMT      PIC X(04).
009400     05 DTMAJ-PMT      PIC 9(06).
009500     05 MONT1-PMT      PIC 9(07).
009600     05 MONT2-PMT      PIC 9(07).
009700
009800 FD  FICMVT  RECORD CONTAINS 10 CHARACTERS.
009900 01  ART-MVT.
010000     05 INDIC-MVT      PIC X(04).
010100     05 CODEV-MVT      PIC X(01).
010200     05 MONTA-MVT      PIC 9(05).
010300
010400 FD  FICOUT  RECORD CONTAINS 24 CHARACTERS.
010500 01  ART-OUT.
010600     05 INDIC-OUT      PIC X(04).
010700     05 DTMAJ-OUT      PIC 9(06).
010800     05 MONT1-OUT      PIC 9(07).
010900     05 MONT2-OUT      PIC 9(07).
011000*
011100 WORKING-STORAGE SECTION.
011200*=======================
011300 01  FS-PMT            PIC  X(02) VALUE SPACES.
011400 01  FS-MVT            PIC  X(02) VALUE SPACES.
011500 01  FS-OUT            PIC  X(02) VALUE SPACES.
011600
011700 01  NOM-PMT           PIC  X(08) VALUE "FICPMT".
011800 01  NOM-MVT           PIC  X(08) VALUE "FICMVT".
011900 01  NOM-OUT           PIC  X(08) VALUE "FICOUT".
012000 01  GESTFST           PIC  X(07) VALUE "GESTFST".
012100 01  RC                PIC S9(05) VALUE ZERO.
012200 01  DATE-JOUR         PIC  9(06) VALUE ZERO.
012300
012400*----Zone de lecture du fichier permanent-----------------------
012500 01  ART-PMT-LU.
012600     05 INDIC-PMT-LU   PIC X(04).
012700     05 DTMAJ-PMT-LU   PIC 9(06).
012800     05 MONT1-PMT-LU   PIC 9(07).
012900     05 MONT2-PMT-LU   PIC 9(07).
013000
013100*----Zone de lecture du fichier mouvement-----------------------
013200 01  ART-MVT-LU.
013300     05 INDIC-MVT-LU   PIC X(04).
013400     05 CODEV-MVT-LU   PIC X(01).
013500     05 MONTA-MVT-LU   PIC 9(05).
013600
013700*----Zone de stockage 1er mouvement d'un groupe de meme indic---
013800 01  ART-MVT-ST.
013900     05 INDIC-MVT-ST   PIC X(04).
014000     05 CODEV-MVT-ST   PIC X(01).
014100     05 MONTA-MVT-ST   PIC 9(05).
014200
014300*----Zone de gestion du fichier sortie (permanent mis a jour)---
014400 01  ART-OUT-WS.
014500     05 INDIC-OUT-WS   PIC X(04).
014600     05 DTMAJ-OUT-WS   PIC 9(06).
014700     05 MONT1-OUT-WS   PIC 9(07).
014800     05 MONT2-OUT-WS   PIC 9(07).
014900
015000*----------------------------------------------------------------
015100* Stats - Ajustement :  NB-PMT-LU + NB-PMT-CREE = NB-OUT-ECRIT
015200*----------------------------------------------------------------
015300 01  NB-PMT-LU     PIC S9(06) COMP VALUE ZERO.
015400 01  NB-PMT-CREE   PIC S9(06) COMP VALUE ZERO.
015500 01  NB-OUT-ECRIT  PIC S9(06) COMP VALUE ZERO.
015600 01  NB-MVT-LU     PIC S9(06) COMP VALUE ZERO.
015700
015800*----------------------------------------------------------------
015900*  Gestion de l'affichage des libelles d'erreurs
016000*----------------------------------------------------------------
016100 01  LIB-ERR.
016200     05 COD-ERR             PIC 9(02).
016300     05 FILLER              PIC X(01).
016400     05 TXT-ERR             PIC X(70).
016500 01  DSP-ERR.
016600     05 DSP1-ERR            PIC X(13).
016700     05 FILLER              PIC X(01) VALUE SPACES.
016800     05 DSP2-ERR            PIC X(70).
016900 01  NAT1-ERR               PIC X(13) VALUE "---APP01P0N--".
017000 01  NAT8-ERR               PIC X(13) VALUE "...........LU".
017100 01  NAT9-ERR               PIC X(13) VALUE "***APP01P0N**".
017200
017300 PROCEDURE DIVISION.
017400*===================
017500*----------------------------------------------------------------
017600* La gestion des erreurs fichiers se fait par DECLARATIVES
017700*    Le module GESTFST ne fait que decortiquer le FILE STATUS
017800*    informe de l'erreur par un display et renvoie un RC
017900*    Voir ce programme pour la nature du RC
018000*
018100* Dans ce programme en sortie de DECLARATIVES on retourne
018200* systematiquement au traitement appelant (FILE SATUS inchange)
018300* Il faut donc tester le FILE-STATUS en retour
018400*    - OPEN/CLOSE erreur si FS autre que "00"
018500*    - READ       erreur si FS autre que "00" ou "10"
018600*    - WRITE      erreur si FS autre que "00"
018700*
018800* Les declaratives sont appelees s'il y a un incident sur une
018900*     operation I/O (OPEN/CLOSE/READ/WRITE).
019000*
019100*----------------------------------------------------------------
019200 DECLARATIVES.
019300 ERREUR-FICPMT SECTION.
019400     USE AFTER STANDARD ERROR PROCEDURE ON FICPMT.
019500     IF FS-PMT NOT = "00"
019600        CALL GESTFST USING "FICPMT" FS-PMT RC
019700     END-IF.
019800*----------------------------------------------------------------
019900 ERREUR-FICMVT SECTION.
020000     USE AFTER STANDARD ERROR PROCEDURE ON FICMVT.
020100     IF FS-MVT NOT = "00"
020200        CALL GESTFST USING "FICMVT" FS-MVT RC
020300     END-IF.
020400*----------------------------------------------------------------
020500 ERREUR-FICOUT SECTION.
020600     USE AFTER STANDARD ERROR PROCEDURE ON FICOUT.
020700     IF FS-OUT NOT = "00"
020800        CALL GESTFST USING "FICOUT" FS-OUT RC
020900     END-IF.
021000 END DECLARATIVES.
021100*-----------------------------------------------------------------
021200
021300 MAIN-PROC SECTION.
021400*================================================================
021500* Cinematique generale
021600*================================================================
021700D    READY TRACE.
021800 DEBUT.
021900     PERFORM INITIALISATIONS-DEBUT-PGM.
022000     PERFORM TRAITEMENT-PGM.
022100     PERFORM TRAITEMENT-FINAL-PGM.
022200 FIN. GO TO RETOUR.
022300
022400*================================================================
022500* Initialisations de debut de programme
022600*  - Ouverture des fichiers
022700*  - Lire le fichier permanent
022800*  - Lire le fichier mouvement
022900*================================================================
023000 INITIALISATIONS-DEBUT-PGM.
023100     MOVE ZERO TO RC.
023200     ACCEPT DATE-JOUR FROM DATE.
023300
023400     OPEN INPUT FICPMT.
023500     IF FS-PMT NOT = "00"
023600        MOVE "90 PROBLEME A L'OPEN FICPMT " TO LIB-ERR
023700        PERFORM DISPLAY-ERR
023800     END-IF.
023900
024000     OPEN INPUT  FICMVT.
024100     IF FS-MVT NOT = "00"
024200        MOVE "90 PROBLEME A L'OPEN FICMVT " TO LIB-ERR
024300        PERFORM DISPLAY-ERR
024400     END-IF.
024500
024600     OPEN OUTPUT FICOUT.
024700     IF FS-OUT NOT = "00"
024800        MOVE "90 PROBLEME A L'OPEN FICOUT " TO LIB-ERR
024900        PERFORM DISPLAY-ERR
025000     END-IF.
025100
025200     PERFORM READ-FICPMT.
025300     PERFORM READ-FICMVT.
025400
025500*================================================================
025600* Traitement principal
025700* La 1ere fois il existe un permanent et un mouvement lu en WSS
025800* En fin de boucle quel que soit le cas on aura egalement un
025900* MVT et un PMT lus en attente de traitement c'est a dire les
026000* les memes conditions que la 1ere fois
026100*================================================================
026200 TRAITEMENT-PGM.
026300     PERFORM WITH TEST BEFORE UNTIL INDIC-PMT-LU = INDIC-MVT-LU
026400                                AND INDIC-PMT-LU = HIGH-VALUE
026500       EVALUATE TRUE
026600         WHEN INDIC-PMT-LU = INDIC-MVT-LU
026700              MOVE ART-PMT-LU TO ART-OUT-WS
026800              PERFORM PMT-ET-MVT
026900              PERFORM READ-FICPMT
027000
027100         WHEN INDIC-PMT-LU > INDIC-MVT-LU
027200              PERFORM MVT-SEUL
027300
027400         WHEN INDIC-PMT-LU < INDIC-MVT-LU
027500              MOVE ART-PMT-LU TO ART-OUT-WS
027600              PERFORM PMT-SEUL
027700              PERFORM READ-FICPMT
027800       END-EVALUATE
027900    END-PERFORM.
028000
028100*----------------------------------------------------------------
028200* Traitement de mise a jour du PMT par MVT
028300* La zone article en WSS de FICOUT est garnie et recoit les maj
028400*----------------------------------------------------------------
028500 PMT-ET-MVT.
028600     PERFORM MISE-A-JOUR-PREMIER.
028700     PERFORM MISE-A-JOUR-TOUS.
028800     PERFORM RELIRE-MVT.
028900
029000*----------------------------------------------------------------
029100* Traitement mouvement seul. Il va y avoir creation d'un PMT
029200* ne pas oublier qu'il y a un PMT en attente
029300*----------------------------------------------------------------
029400 MVT-SEUL.
029500     PERFORM INITIALISER-PMT.
029600     PERFORM PMT-ET-MVT.
029700
029800*----------------------------------------------------------------
029900* Traitement permanent seul. on va reconduire le PMT tel quel
030000* la gestion lecture du PMT se fait dans la boucle principale
030100* ne pas oublier qu'il y a un MVT en attente
030200*----------------------------------------------------------------
030300 PMT-SEUL.
030400     PERFORM WRITE-FICOUT.
030500
030600*----------------------------------------------------------------
030700* Traitement specifique de mise a jour par un mouvement
030800* Il s'agit du 1er mouvement d'un groupe de meme indicatif
030900*----------------------------------------------------------------
031000 MISE-A-JOUR-PREMIER.
031100     MOVE    DATE-JOUR    TO DTMAJ-OUT-WS.
031200
031300*----------------------------------------------------------------
031400* Traitement mise a jour commun a tous les mouvements
031500* d'un groupe de meme indicatif
031600*----------------------------------------------------------------
031700 MISE-A-JOUR-TOUS.
031800     EVALUATE CODEV-MVT-LU
031900         WHEN "1" ADD MONTA-MVT-LU TO MONT1-OUT-WS
032000         WHEN "2" ADD MONTA-MVT-LU TO MONT2-OUT-WS
032100     END-EVALUATE.
032200
032300*----------------------------------------------------------------
032400* Traitement d'initialisation d'un permanent avec le premier
032500* mouvement d'un groupe de meme indicatif
032600*----------------------------------------------------------------
032700 INITIALISER-PMT.
032800     MOVE SPACES       TO ART-OUT-WS.
032900     MOVE INDIC-MVT-LU TO INDIC-OUT-WS.
033000     MOVE ZERO         TO MONT1-OUT-WS MONT2-OUT-WS.
033100     ADD 1 TO NB-PMT-CREE.
033200
033300*----------------------------------------------------------------
033400* Stocker le premier mouvement d'un groupe de meme indicatif
033500* Boucler en mise a jour jusqu'a la rupture d'indicatif
033600*   Relire MVT
033700*   Ecrire le permanent mis a jour en rupture d'indicatif
033800*          sinon faire la mise a jour commune a tout le groupe
033900* En sortie de boucle le MVT lu est en attente de traitement
034000*----------------------------------------------------------------
034100 RELIRE-MVT.
034200     MOVE ART-MVT-LU TO ART-MVT-ST.
034300     PERFORM UNTIL INDIC-MVT-LU NOT = INDIC-MVT-ST
034400         PERFORM READ-FICMVT
034500         IF INDIC-MVT-LU = INDIC-MVT-ST
034600            PERFORM MISE-A-JOUR-TOUS
034700         ELSE
034800            PERFORM WRITE-FICOUT
034900         END-IF
035000     END-PERFORM.
035100
035200*================================================================
035300* Traitement sortie de programme
035400* (Fin PGM, fermetures, statistiques, etc.)
035500*================================================================
035600 TRAITEMENT-FINAL-PGM.
035700     MOVE ZERO TO RC.
035800
035900     CLOSE FICPMT.
036000     IF FS-PMT NOT = "00"
036100        MOVE "91 PROBLEME AU CLOSE FICPMT " TO LIB-ERR
036200        PERFORM DISPLAY-ERR
036300     END-IF.
036400
036500     CLOSE FICMVT.
036600     IF FS-MVT NOT = "00"
036700        MOVE "91 PROBLEME AU CLOSE FICMVT " TO LIB-ERR
036800        PERFORM DISPLAY-ERR
036900     END-IF.
037000
037100     CLOSE FICOUT.
037200     IF FS-OUT NOT = "00"
037300        MOVE "91 PROBLEME AU CLOSE FICMVT " TO LIB-ERR
037400        PERFORM DISPLAY-ERR
037500     END-IF.
037600
037700     DISPLAY NAT1-ERR " NB ENREG PMT LUS    =" NB-PMT-LU.
037800     DISPLAY NAT1-ERR " NB ENREG PMT CREES  =" NB-PMT-CREE.
037900     DISPLAY NAT1-ERR " NB ENREG PMT ECRITS =" NB-OUT-ECRIT.
038000     DISPLAY NAT1-ERR " NB ENREG MVT LUS    =" NB-MVT-LU.
038100
038200*----------------------------------------------------------------
038300* Lecture physique du permanent en WSS via un READ INTO
038400* En fin de fichier on force l'indicatif lu a HIGH-VALUE
038500* Le traitement sera termine quand les indicatifs PMT et MVT
038600* seront tous les deux egaux a HIGH-VALUE
038700*----------------------------------------------------------------
038800 READ-FICPMT.
038900     MOVE SPACES TO ART-PMT-LU.
039000     READ FICPMT INTO   ART-PMT-LU
039100                 AT END MOVE HIGH-VALUE TO INDIC-PMT-LU.
039200     IF FS-PMT NOT = "00" AND NOT = "10"
039300        MOVE "93 PROBLEME AU READ FICPMT " TO LIB-ERR
039400        PERFORM DISPLAY-ERR
039500     END-IF.
039600     IF INDIC-PMT-LU NOT = HIGH-VALUE
039700        ADD 1 TO NB-PMT-LU
039800     END-IF.
039900
040000*----Pour debbuging a commenter en fonctionnement reel-----------
040100*    DISPLAY NAT1-ERR " ARTICLE PMT LU="
040200*            INDIC-PMT-LU " "
040300*            DTMAJ-PMT-LU " "
040400*            MONT1-PMT-LU " "
040500*            MONT2-PMT-LU " ".
040600
040700*----------------------------------------------------------------
040800* Lecture physique du mouvement en WSS via un READ INTO
040900* En fin de fichier on force l'indicatif lu a HIGH-VALUE
041000*----------------------------------------------------------------
041100 READ-FICMVT.
041200     MOVE SPACES TO ART-MVT-LU.
041300     READ FICMVT INTO   ART-MVT-LU
041400                 AT END MOVE HIGH-VALUE TO INDIC-MVT-LU.
041500     IF FS-MVT NOT = "00" AND NOT = "10"
041600        MOVE "93 PROBLEME AU READ FICMVT " TO LIB-ERR
041700        PERFORM DISPLAY-ERR
041800     END-IF.
041900     IF INDIC-MVT-LU NOT = HIGH-VALUE
042000        ADD 1 TO NB-MVT-LU
042100     END-IF.
042200
042300*----Pour debbuging a commenter en fonctionnement reel-----------
042400*    DISPLAY NAT1-ERR " ARTICLE MVT LU="
042500*            INDIC-MVT-LU " "
042600*            CODEV-MVT-LU " "
042700*            MONTA-MVT-LU " ".
042800
042900*----------------------------------------------------------------
043000* Ecriture physique du permanent apres mise a jour
043100*----------------------------------------------------------------
043200 WRITE-FICOUT.
043300     WRITE ART-OUT FROM ART-OUT-WS.
043400     IF FS-OUT NOT = "00"
043500        MOVE "93 PROBLEME AU WRITE FICOUT " TO LIB-ERR
043600        PERFORM DISPLAY-ERR
043700     END-IF.
043800     ADD 1 TO NB-OUT-ECRIT.
043900
044000*----Pour debbuging a commenter en fonctionnement reel-----------
044100     DISPLAY NAT1-ERR " ARTICLE  ECRIT="
044200             INDIC-OUT-WS " "
044300             DTMAJ-OUT-WS " "
044400             MONT1-OUT-WS " "
044500             MONT2-OUT-WS " ".
044600
044700*----------------------------------------------------------------
044800* Gestion des erreurs
044900* Le libelle des erreur est dans la zone LIB-ERR
045000* Si ce libelle commence par
045100*  - 01-09 Display du libelle erreur + MVT lu et on continue
045200*  - 10-19 Display du libelle erreur + MVT mais on arrete
045300*  - 20-29 Display du libelle erreur + PMT lu et on continue
045400*  - 30-39 Display du libelle erreur + PMT lu mais on arrete
045500*  - 40-49 Display du libelle erreur + OUT et on arrete
045600*  - 90-99 Display du libelle erreur seul et on arrete
045700*----------------------------------------------------------------
045800 DISPLAY-ERR.
045900     MOVE SPACES  TO DSP-ERR.
046000     MOVE TXT-ERR TO DSP2-ERR.
046100     EVALUATE COD-ERR
046200       WHEN 01 THRU 09
046300         MOVE NAT1-ERR TO DSP1-ERR
046400         DISPLAY DSP-ERR
046500         MOVE SPACES   TO DSP1-ERR
046600         DISPLAY DSP1-ERR
046700                 "/ART-MVT-LU=" ART-MVT-LU
046800
046900       WHEN 10 THRU 19
047000         MOVE NAT9-ERR TO DSP1-ERR
047100         DISPLAY DSP-ERR
047200         MOVE SPACES   TO DSP1-ERR
047300         DISPLAY DSP1-ERR
047400                 "/ART-MVT-LU=" ART-MVT-LU
047500         GO TO RETOUR
047600
047700       WHEN 20 THRU 29
047800         MOVE NAT1-ERR TO DSP1-ERR
047900         DISPLAY DSP-ERR
048000         MOVE SPACES   TO DSP1-ERR
048100         DISPLAY DSP1-ERR
048200                 "/ART-PMT-LU=" ART-PMT-LU
048300
048400       WHEN 30 THRU 39
048500         MOVE NAT9-ERR TO DSP1-ERR
048600         DISPLAY DSP-ERR
048700         MOVE SPACES   TO DSP1-ERR
048800         DISPLAY DSP1-ERR
048900                 "/ART-PMT-LU=" ART-PMT-LU
049000         GO TO RETOUR
049100
049200       WHEN 40 THRU 49
049300         MOVE NAT9-ERR TO DSP1-ERR
049400         DISPLAY DSP-ERR
049500         MOVE SPACES   TO DSP1-ERR
049600         DISPLAY DSP1-ERR
049700                 "/ART-OUT-WS=" ART-OUT-WS
049800         GO TO RETOUR
049900
050000       WHEN OTHER
050100         MOVE NAT9-ERR TO DSP1-ERR
050200         DISPLAY DSP-ERR
050300         GO TO RETOUR
050400     END-EVALUATE.
050500
050600*--- Il est bien que RETOUR soit la derniere ligne du programme
050700 RETOUR. GOBACK.
050800 END PROGRAM APP01P0N.
